*DECK XDRVER
      SUBROUTINE XDRVER(IMVERS,ISVERS,IVDATE)
*
*-----------------------------------------------------------------------
*
*Purpose:
* To extract DRAGON version and production date.
*
*Copyright:
* Copyright (C) 2004 Ecole Polytechnique de Montreal
*
*Author(s): G. Marleau
*
*Parameters: input
* IMVERS  main DRAGON version number.
* ISVERS  sub version  number.
* IVDATE  DRAGON production date where:
*         \begin{itemize} 
*         \item \verb|IVDATE(1)| is the production year;
*         \item \verb|IVDATE(2)| is the production month;
*         \item \verb|IVDATE(3)| is the production day.
*         \end{itemize} 
*
*-----------------------------------------------------------------------
*
      IMPLICIT    NONE
      INTEGER     IMVERS,ISVERS,IVDATE(3)
      IMVERS = 3
      ISVERS = 6
      IVDATE(1)=2008
      IVDATE(2)=03
      IVDATE(3)=14
      RETURN
      END
