      SUBROUTINE XSMCL(IPLIST,ISTATU)
*
*-----------------------------------------------------------------------
*
* CLOSE THE XSM FILE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*  ISTATU : =1 TO KEEP THE FILE AT CLOSE ; =2 TO DESTROY IT.
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
*     IPRIM=ADDRESS OF THE ROOT DIRECTORY.
      PARAMETER (IPRIM=3,IOFMAX=30)
      INTEGER PFXSM
      CHARACTER HNAME*12,HSMG*131,MYNAME*12,CMT(IOFMAX)*12
      PARAMETER (IHEAD=0,IHNAM=1,IMODIF=4,IIFILE=5,INMT=6,ILINK=7,
     1 IIROOT=8,IIOFS=9,IJLON=9+IOFMAX,IJTYP=9+2*IOFMAX,
     2 IIDIR=9+3*IOFMAX,IIOFT=10+3*IOFMAX,IIMPF=11+3*IOFMAX,
     3 IMYNAM=12+3*IOFMAX,ICMT=15+3*IOFMAX)
      LOGICAL LBASE(1)
      COMMON IBASE(1)
      EQUIVALENCE (IBASE(1),LBASE(1))
*
      PFXSM=IPLIST
      WRITE(HNAME,'(3A4)') (IBASE(PFXSM+IHNAM+I),I=0,2)
      IF((IBASE(PFXSM+IIMPF).EQ.2).AND.(ISTATU.EQ.2)) THEN
         WRITE(HSMG,'(36HXSMCL: CANNOT DESTROY THE XSM FILE '',A12,
     1   25H'' OPEN IN READ-ONLY MODE.)') HNAME
         WRITE(6,'(/1X,A131)') HSMG
         STOP
      ELSE IF((ISTATU.LT.1).OR.(ISTATU.GT.2)) THEN
         WRITE(HSMG,'(23HXSMCL: INVALID ACTION (,I3,14H) FOR XSM FILE,
     1   2H '',A12,2H''.)') ISTATU,HNAME
         WRITE(6,'(/1X,A131)') HSMG
         STOP
      ELSE IF(IBASE(PFXSM+IHEAD).NE.200) THEN
         WRITE(HSMG,'(21HXSMCL: THE XSM FILE '',A12,14H'' HAVE THE WRO,
     1   10HNG HEADER.)') HNAME
         WRITE(6,'(/1X,A131)') HSMG
         STOP
      ENDIF
      IF(LBASE(PFXSM+IMODIF)) THEN
         IF(IBASE(PFXSM+IIMPF).EQ.2) THEN
            WRITE(HSMG,'(21HXSMCL: THE XSM FILE '',A12,12H'' IS OPEN IN,
     1      20H READ-ONLY MODE (1).)') HNAME
            WRITE(6,'(/1X,A131)') HSMG
            STOP
         ENDIF
         DO 10 J=1,IBASE(PFXSM+INMT)
         WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   10    CONTINUE
         WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
         CALL XSMDIR(2,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1   IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2   IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3   IBASE(PFXSM+IIDIR))
      ENDIF
      IF(IBASE(PFXSM+IIMPF).EQ.2) THEN
         CALL XSMDIR(1,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1   IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2   IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),IPRIM)
         READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
         DO 20 J=1,IBASE(PFXSM+INMT)
         READ(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   20    CONTINUE
      ENDIF
      CALL KDIGET(IBASE(PFXSM+IIFILE),III,1,1,IRC)
      IF(IRC.NE.0) GO TO 140
      IF(IBASE(PFXSM+IIOFT).GT.III) THEN
         IF(IBASE(PFXSM+IIMPF).EQ.2) THEN
            WRITE(HSMG,'(21HXSMCL: THE XSM FILE '',A12,12H'' IS OPEN IN,
     1      20H READ-ONLY MODE (2).)') HNAME
            WRITE(6,'(/1X,A131)') HSMG
            STOP
         ENDIF
         CALL KDIPUT(IBASE(PFXSM+IIFILE),IBASE(PFXSM+IIOFT),1,1,IRC)
         IF(IRC.NE.0) GO TO 150
      ENDIF
      CALL KDIGET(IBASE(PFXSM+IIFILE),III,2,1,IRC)
      IF(IRC.NE.0) GO TO 140
      IF((IBASE(PFXSM+IIDIR).NE.III).AND.(IBASE(PFXSM+IIMPF).LE.1)) THEN
         CALL KDIPUT(IBASE(PFXSM+IIFILE),IBASE(PFXSM+IIDIR),2,1,IRC)
         IF(IRC.NE.0) GO TO 150
      ENDIF
      IRC=KDRCLS(IBASE(PFXSM+IIFILE),ISTATU)
      IF(IRC.NE.0) THEN
         WRITE(HSMG,'(22HXSMCL: KDICL ERROR NB.,I6,14H ON XSM FILE '',
     1   A12,2H''.)') IRC,HNAME
         WRITE(6,'(/1X,A131)') HSMG
         STOP
      ENDIF
*
* RELEASE THE XSM FILE HANDLE.
      IBASE(PFXSM+IIFILE)=0
      IBASE(PFXSM+IHEAD)=0
      CALL RLSARA(IBASE(PFXSM))
      IPLIST=0
      RETURN
*
  140 WRITE(HSMG,'(23HXSMCL: KDIGET ERROR NB.,I6,14H ON XSM FILE '',A12,
     1 2H''.)') IRC,HNAME
      WRITE(6,'(/1X,A131)') HSMG
      STOP
  150 WRITE(HSMG,'(23HXSMCL: KDIPUT ERROR NB.,I6,14H ON XSM FILE '',A12,
     1 2H''.)') IRC,HNAME
      WRITE(6,'(/1X,A131)') HSMG
      STOP
      END
