*DECK FLUGFL
      SUBROUTINE FLUGFL(IPFLUX,NGROUP,NUNKNO,FUNKNO)
C
C---------------------------  FLUGFL  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : FLUGFL
C       USE      : GET FLUX FROM IPFLUX
C       MODIFIED : 2000-01-20  (G. MARLEAU)
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT:
C      IPFLUX  : FULS DATA STRUCTURE POINTER          I
C      NGROUP  : NUMBER OF GROUPS.                    I
C      NUNKNO  : NUMBER OF UNKNOWN IN THE SYSTEM.     I
C      FUNKNO  : UNKNOWN VECTOR SOLVED FOR.           R(NUNKNO,NGROUP)
C
C---------------------------   FLUGFL  --------------------------------
C
      IMPLICIT    NONE
      CHARACTER   NAMSBR*6
      PARAMETER  (NAMSBR='FLUGFL')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPFLUX,NGROUP,NUNKNO
      REAL        FUNKNO(NUNKNO,NGROUP)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CDIRN*12
      INTEGER     IGROUP,ILCMLN,ILCMTY
C----
C  GET UNKNOWN VECTOR FROM IPFLUX
C----
      DO 100 IGROUP=1,NGROUP
        WRITE(CDIRN,'(4HFLUX,I3)') IGROUP
        CALL LCMLEN(IPFLUX,CDIRN,ILCMLN,ILCMTY)
        IF(ILCMLN .GT. 0 .AND. ILCMLN .LE. NUNKNO) THEN
          CALL LCMGET(IPFLUX,CDIRN,FUNKNO(1,IGROUP))
        ENDIF
 100  CONTINUE
      RETURN
      END
