*DECK MCI2KF
      SUBROUTINE MCI2KF(ITYPEC,NGRP,NREG,NANIS,NMAT,NSOUT,LEAKSW,OLDBIL,
     >                  MATCOD,VOL,FLUX,
     >                  XSTOT,XSCAT,NIFIS,XSNUF,XSCHI,DB2,
     >                  AKEFF,AFLNOR)
      IMPLICIT NONE
      LOGICAL LEAKSW
      INTEGER ITYPEC,NGRP,NREG,NANIS,NMAT,NSOUT,NIFIS,MATCOD(NREG)
      INTEGER IG,  IR,        IS,  JG, IPRT
      REAL    VOL(NREG),DB2(NGRP),
     >        XSTOT(0:NMAT,NGRP),XSCAT(NGRP,0:NMAT,0:NANIS,NGRP),
     >        XSNUF(0:NMAT,NIFIS,NGRP),XSCHI(0:NMAT,NIFIS,NGRP)
      DOUBLE PRECISION
     >        FLUX(NGRP,-NSOUT:NREG)
      DOUBLE PRECISION PROD,LOSS,SUMCHI,FISOUR,SUMLOS,
     >                 OLDBIL,AKEFF,AFLNOR,DZERO,DONE
      DOUBLE PRECISION BIL21,BIL22,BIL23
C
      PARAMETER ( DZERO=0.0D0, DONE=1.0D0 )
      IPRT= 0
      IF( IPRT.EQ.5 )THEN
         WRITE(6,*) ' ROY:'
         IF( ITYPEC.GT.1 )THEN
            DO 25 IG=1,NGRP
               WRITE(6,*) ' ROY: DB2(',IG,')=',DB2(IG)
  25        CONTINUE
         ENDIF
         WRITE(6,*) ' ROY:'
         WRITE(6,*) ' ROY: OLDBIL=',OLDBIL
      ENDIF
      PROD= DZERO
      DO 30 IR=1,NREG
         DO 20 IS=1,NIFIS
            SUMCHI= DZERO
            FISOUR= DZERO
            DO 10 IG=1,NGRP
               FISOUR= FISOUR + XSNUF(MATCOD(IR),IS,IG)*FLUX(IG,IR)
               SUMCHI= SUMCHI + XSCHI(MATCOD(IR),IS,IG)
   10       CONTINUE
            PROD= PROD + SUMCHI*FISOUR*VOL(IR)
   20    CONTINUE
   30 CONTINUE
      IF( PROD.GT.DZERO )THEN
         AFLNOR= DONE/PROD
      ELSE
         AFLNOR= DONE
      ENDIF
      LOSS= DZERO
      BIL21= DZERO
      BIL22= DZERO
      BIL23= DZERO
      DO 60 IR=1,NREG
         SUMLOS= DZERO
         DO 50 IG=1,NGRP
            BIL22= BIL22+XSTOT(MATCOD(IR),IG)*FLUX(IG,IR)*VOL(IR)
            SUMLOS= SUMLOS+XSTOT(MATCOD(IR),IG)*FLUX(IG,IR)
            BIL21= BIL21+DB2(IG)*FLUX(IG,IR)*VOL(IR)
            SUMLOS= SUMLOS+DB2(IG)*FLUX(IG,IR)
            DO 40 JG=1,NGRP
               SUMLOS= SUMLOS-XSCAT(JG,MATCOD(IR),0,IG)*FLUX(JG,IR)
               BIL23= BIL23
     >               -XSCAT(JG,MATCOD(IR),0,IG)*FLUX(JG,IR)*VOL(IR)
   40       CONTINUE
   50    CONTINUE
         LOSS= LOSS + SUMLOS*VOL(IR)
   60 CONTINUE
CMD      write(*,*)'LEAKSW=====',LEAKSW
      IF( LEAKSW )THEN
         IF( OLDBIL.GT.DZERO )THEN
            AKEFF= PROD/OLDBIL
         ELSE
            AKEFF= PROD
         ENDIF
      ELSE
         IF( LOSS.GT.DZERO )THEN
            AKEFF=  PROD/LOSS
            AFLNOR= AFLNOR*LOSS
         ELSE
            AKEFF=  PROD
         ENDIF
      ENDIF
      OLDBIL= PROD*AFLNOR
      IF( IPRT.GT.2 )THEN
         WRITE(6,*) ' ROY: PROD=', PROD
         WRITE(6,*) ' ROY: LOSS=', LOSS
         WRITE(6,*) ' ROY: LOSS(BIL21(+DB2))=',BIL21
         WRITE(6,*) ' ROY: LOSS(BIL22(+SIGT0))=',BIL22
         WRITE(6,*) ' ROY: LOSS(BIL23(-SCATT))=',BIL23
         WRITE(6,*) ' ROY: KEFF=',AKEFF
      ENDIF
      RETURN
      END
