*DECK MOC2BN
      SUBROUTINE MOC2BN(NGRP,NANIS,NBN,PHI,
     >                  XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,
     >                  DIFF,BETA,REBAL,FLUN,REFKEF,EBMX,B2,IPRT )
      IMPLICIT NONE
      INTEGER NGRP,NANIS,NBN,IOUT
      INTEGER IGRP,IPRT,JGRP,KGRP,ITEX,IER
      DOUBLE PRECISION PHI(NGRP),DIFF(NGRP),XCTOT(NGRP),XCTRC(NGRP),
     >        XCDIA(NGRP),XCABS(NGRP),XCCAT(NGRP,0:NANIS,NGRP),
     >        XCNUF(NGRP),XCCHI(NGRP),FLUN(NGRP)
      DOUBLE PRECISION EPS,B2,SQRTB2,TMP,BIL1,BIL2,ST,ST2,DD,ALPHAS,
     >        DZERO,DONE,REFKEF,A2,ALAM1,ALAM2,ZXC,CAET,ERR3,SS,
     >        REBAL(NGRP,NGRP+1),BETA(NGRP),TRAN1,SOUR1
      REAL    ZERO, EBMX
      CHARACTER*4 TYPE
      CHARACTER*131 HSMG
      PARAMETER (IOUT=6,ZERO=0.0, DZERO=0.0D0, DONE=1.0D0 )
      EPS=DBLE(EBMX)
      TYPE= 'B'
      BIL1= DZERO
      BIL2= DZERO
      DO 20 IGRP= 1, NGRP
         BIL1=BIL1+(XCNUF(IGRP)/REFKEF-XCABS(IGRP))*PHI(IGRP)
         BIL2=BIL2+DIFF(IGRP)*PHI(IGRP)
         FLUN(IGRP)= PHI(IGRP)
   20 CONTINUE
      B2=BIL1/BIL2
      IF(IPRT.GT.2) WRITE(IOUT,420) B2
      ITEX=0
   30 ITEX=ITEX+1
      IF(ITEX.GT.50) CALL XABORT('MOC2BN: UNABLE TO CONVERGE(1).')
      SQRTB2= SQRT(ABS(B2))
      DO 55 IGRP= 1,NGRP
         IF( NBN.EQ.0 )THEN
            ST=   XCTRC(IGRP)
            SS=   XCDIA(IGRP)
         ELSE
            ST=   XCTOT(IGRP)
            SS=   XCCAT(IGRP,0,IGRP)
         ENDIF
         ST2=  ST*ST
         DD=   DIFF(IGRP)
         IF (B2.GT.0.05D0*ST2) THEN
            TMP=SQRTB2/ST
            BETA(IGRP)=(DONE-ATAN(TMP)/TMP)/B2
         ELSE IF ((B2.LT.-0.05D0*ST2).AND.(B2.GE.-0.995D0*ST2)) THEN
            TMP=SQRTB2
            BETA(IGRP)=(DONE-0.5D0*ST*LOG((ST+TMP)/(ST-TMP))/TMP)/B2
         ELSE IF((B2.LE.0.05D0*ST2).AND.(B2.GE.-0.05D0*ST2)) THEN
            TMP=B2/ST2
            BETA(IGRP)=(DONE-3.0D0*TMP*(0.2D0-TMP/7.0D0+TMP*TMP/9.0D0
     >      -TMP*TMP*TMP/11.0D0))/(3.0D0*ST2)
         ELSE
            WRITE(HSMG,'(22HMOC2BN: THE BUCKLING (,1P,E12.4,8H) IS SMA,
     1      9HLLER THAN,E12.4,1H.)') B2,-0.995D0*ST2
            CALL XABORT(HSMG)
         ENDIF
         ALPHAS= DONE-B2*BETA(IGRP)
         DO 40 JGRP=1,NGRP
            REBAL(IGRP,JGRP)= DZERO
   40    CONTINUE
         DO 50 JGRP= 1, NGRP
            REBAL(IGRP,JGRP)= -ALPHAS*XCCAT(JGRP,0,IGRP)
   50    CONTINUE
         REBAL(IGRP,IGRP)=  ST-ALPHAS*SS
         REBAL(IGRP,NGRP+1)=   ALPHAS*XCCHI(IGRP)
   55 CONTINUE
      IF( NBN.GE.1 ) THEN
         DO 80 IGRP=1,NGRP
            SOUR1= DZERO
            ALPHAS= BETA(IGRP)*XCTOT(IGRP)
         DO 70 JGRP=1,NGRP
            SOUR1= SOUR1+XCCAT(JGRP,1,IGRP)*XCCHI(JGRP)
            TRAN1= -XCCAT(JGRP,1,IGRP)*XCTOT(JGRP)
         DO 60 KGRP=1,NGRP
            TRAN1= TRAN1+XCCAT(KGRP,1,IGRP)*XCCAT(JGRP,0,KGRP)
   60    CONTINUE
            REBAL(IGRP,JGRP)= REBAL(IGRP,JGRP)+ALPHAS*TRAN1
   70    CONTINUE
            REBAL(IGRP,NGRP+1)= REBAL(IGRP,NGRP+1)-ALPHAS*SOUR1
   80    CONTINUE
      ENDIF
      CALL MOCSOL(NGRP,1,REBAL,IER,NGRP)
      IF(IER.NE.0) CALL XABORT('MOC2BN: SINGULAR MATRIX(1).')
      ALAM1= DZERO
      CAET=  DZERO
      DO 130 IGRP= 1, NGRP
         ALAM1= ALAM1+XCNUF(IGRP)*REBAL(IGRP,NGRP+1)
         CAET=  CAET+XCABS(IGRP)*REBAL(IGRP,NGRP+1)
  130 CONTINUE
      IF(IPRT.GT.2) WRITE(IOUT,430) ITEX,ALAM1
      IF(TYPE.EQ.'K') THEN
         DO 140 IGRP=1,NGRP
  140    FLUN(IGRP)=REBAL(IGRP,NGRP+1)/ALAM1
      ELSE IF(TYPE.EQ.'B') THEN
*        COMPUTE THE EXTRAPOLATED BUCKLING.
         B2=B2*(ALAM1/REFKEF-CAET)/(DONE-CAET)
*        CHECK THE CONVERGENCE.
         BIL1= DZERO
         BIL2= DZERO
         DO 150 IGRP=1,NGRP
         IF( NBN.EQ.0 )THEN
            ST2= XCTRC(IGRP)*XCTRC(IGRP)
         ELSE
            ST2= XCTOT(IGRP)*XCTOT(IGRP)
         ENDIF
         IF(B2.LT.-0.995D0*ST2) THEN
            WRITE(HSMG,'(35HMOC2BN: THE EXTRAPOLATED BUCKLING (,
     >      1P,E12.4,
     >      17H) IS SMALLER THAN,E12.4,13H AT ITERATION,I5,1H.)') B2,
     >      -0.995D0*ST2,ITEX
            CALL XABORT(HSMG)
         ENDIF
         BIL1=MAX(BIL1,ABS(REBAL(IGRP,NGRP+1)/ALAM1))
         BIL2=MAX(BIL2,ABS(FLUN(IGRP)-REBAL(IGRP,NGRP+1)/ALAM1))
  150    FLUN(IGRP)=REBAL(IGRP,NGRP+1)/ALAM1
         ERR3=ABS(REFKEF-ALAM1)
         IF((BIL2.GE.10*EPS*BIL1).OR.(ERR3.GE.EPS)) GO TO 30
      ENDIF
C
         SQRTB2= SQRT(ABS(B2))
         DO 325 IGRP=1,NGRP
         IF( NBN.EQ.0 )THEN
            ST=   XCTRC(IGRP)
         ELSE
            ST=   XCTOT(IGRP)
         ENDIF
         ST2=  ST*ST
         DD=   DIFF(IGRP)
         IF (B2.GT.0.05D0*ST2) THEN
            TMP=SQRTB2/ST
            BETA(IGRP)=(DONE-ATAN(TMP)/TMP)/B2
         ELSE IF ((B2.LT.-0.05D0*ST2).AND.(B2.GE.-0.995D0*ST2)) THEN
            TMP=SQRTB2
            BETA(IGRP)=(DONE-0.5D0*ST*LOG((ST+TMP)/(ST-TMP))/TMP)/B2
         ELSE IF((B2.LE.0.05D0*ST2).AND.(B2.GE.-0.05D0*ST2)) THEN
            TMP=B2/ST2
            BETA(IGRP)=(DONE-3.0D0*TMP*(0.2D0-TMP/7.0D0+TMP*TMP/9.0D0
     >      -TMP*TMP*TMP/11.0D0))/(3.0D0*ST2)
         ELSE
            WRITE(HSMG,'(22HMOC2BN: THE BUCKLING (,1P,E12.4,8H) IS SMA,
     1      9HLLER THAN,E12.4,1H.)') B2,-0.995D0*ST2
            CALL XABORT(HSMG)
         ENDIF
         ALPHAS= BETA(IGRP)*ST/(DONE-B2*BETA(IGRP))
         DO 310 JGRP=1,NGRP
  310    REBAL(IGRP,JGRP)= DZERO
         REBAL(IGRP,IGRP)= DONE
         REBAL(IGRP,NGRP+1)= ALPHAS
         IF( NBN.GE.1 )THEN
            DO 320 JGRP= 1, NGRP
               REBAL(IGRP,JGRP)=REBAL(IGRP,JGRP)
     >          -ALPHAS*XCCAT(JGRP,1,IGRP)*FLUN(JGRP)/FLUN(IGRP)
  320       CONTINUE
         ENDIF
  325    CONTINUE
         CALL MOCSOL(NGRP,1,REBAL,IER,NGRP)
         IF(IER.NE.0) CALL XABORT('MOC2BN: SINGULAR MATRIX(2).')
         DO 330 IGRP=1,NGRP
            DIFF(IGRP)= REBAL(IGRP,NGRP+1)
  330    CONTINUE
C
      A2=   DZERO
      CAET= DZERO
      ZXC=  DZERO
      DO 350 IGRP=1,NGRP
         A2=   A2+DIFF(IGRP)*FLUN(IGRP)
         CAET= CAET+XCABS(IGRP)*FLUN(IGRP)
         ZXC=  ZXC+XCNUF(IGRP)*FLUN(IGRP)/REFKEF
  350 CONTINUE
      A2=A2/CAET
      CAET=ZXC/CAET
      ALAM2=CAET/(DONE+A2*B2)
      IF(TYPE.EQ.'L') ALAM1=ALAM2
      IF(IPRT.GT.1) THEN
         WRITE(IOUT,450) ITEX,B2,ALAM1,ALAM2,CAET,A2
      ENDIF
      RETURN
*
  400 FORMAT(/43H MOC2BN: DIFFUSION COEFFICIENT CALCULATION.)
  410 FORMAT(/21H MOC2BN: SOLUTION OF ,A4,21H EQUATIONS WITH TYPE ,A4)
  415 FORMAT(48H MOC2BN: THE INITIAL BUCKLING WAS INCREASED FROM,1P,
     1 E13.5,3H TO,E13.5)
  420 FORMAT(27H MOC2BN: INITIAL BUCKLING =,1P,E13.5)
  430 FORMAT(34H MOC2BN: K-EFFECTIVE ITERATION NO.,I3,13H. K-EFFECTIVE,
     1 2H =,F10.6)
  450 FORMAT(8X,22HNUMBER OF ITERATIONS =,I3/8X,10HBUCKLING =,1P,E13.5,
     1 0P/8X,13HK-EFFECTIVE =,F10.6,3H  (,F10.6,2H )/8X,12HK-INFINITE =,
     2 F10.6/8X,16HMIGRATION AREA =,1P,E13.5/)
      END
