      SUBROUTINE LCMPOF(IPLIST,NAMP,ILONG,ITYPE,IOFDUM)
*
*-----------------------------------------------------------------------
*
* ADD A NEW SETARA POINTER ENTRY IN THE LINKED LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST.
*    NAMP : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*   ILONG : NUMBER OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*   ITYPE : TYPE OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*  IOFDUM : SETARA POINTER OF THE FIRST INFORMATION ELEMENT.
*
*------------------------------------- AUTHOR: A. HEBERT ; 29/10/93 ----
*
      PARAMETER (MAXEXT=70,LHASH=251)
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,IMODE=9)
      PARAMETER (JDATA=LHASH+2,JJLON=LHASH+3,JJTYP=LHASH+4,
     1 JIDAT=LHASH+5,JCMT=LHASH+9)
      CHARACTER NAMP*(*),NAMT*12,HSMG*131
      INTEGER IBASE(1),INAMT(3)
      LOGICAL LBASE(1)
      COMMON BASE(1)
      LOGICAL LCATRU
      PARAMETER (LCATRU=.TRUE.)
      EQUIVALENCE (BASE(1),IBASE(1),LBASE(1))
*
      IF(IOFDUM.EQ.0) THEN
         NAMT=NAMP
         WRITE(HSMG,'(36HLCMPOF: THE SETARA POINTER OF NODE '',A12,
     1   40H'' IS NOT ASSOCIATED IN THE LINKED LIST '',3A4,2H''.)')
     2   NAMT,(IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(ILONG.LE.0) THEN
         NAMT=NAMP
         WRITE(HSMG,'(24HLCMPOF: INVALID LENGTH (,I5,12H) FOR NODE '',
     1   A12,22H'' IN THE LINKED LIST '',3A4,2H''.)') ILONG,NAMT,
     2   (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMPUT(IPLIST,NAMP,ILONG,ITYPE,IBASE(IOFDUM))
         CALL RLSARA(IBASE(IOFDUM))
         IOFDUM=0
         RETURN
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(25HLCMPOF: THE LINKED LIST '',3A4,11H'' HAVE THE ,
     1   13HWRONG HEADER.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(25HLCMPOF: THE LINKED LIST '',3A4,12H'' IS CLOSED.
     1   )') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.2) THEN
         WRITE(HSMG,'(25HLCMPOF: THE LINKED LIST '',3A4,11H'' IS OPEN I,
     1   17HN READ-ONLY MODE.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      IPNODE=IBASE(IPLIST+INEXT)
*
* SCAN THE NODAL TABLE AND INCLUDE THE NEW ENTRY.
      NAMT=NAMP
      CALL LCMCAR(NAMT,LCATRU,INAMT)
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      DO 10 I=IBASE(IPNODE+2+IPOS),1,-1
      IF(INAMT(1).EQ.IBASE(IPNODE+10*(I-1)+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(IPNODE+10*(I-1)+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(IPNODE+10*(I-1)+JCMT+2)) THEN
               IREF=I
*              REMOVE THE OLD NODE.
               JOFDUM=IBASE(IPNODE+10*(IREF-1)+JDATA)
               IF(JOFDUM.NE.IOFDUM) CALL RLSARA(IBASE(JOFDUM))
               GO TO 30
            ENDIF
         ENDIF
      ENDIF
   10 CONTINUE
      IREF=IBASE(IPNODE+1)+1
      IF(IREF.GT.IBASE(IPNODE)) THEN
*        INCREASE THE SIZE OF THE NODE TABLE.
         CALL SETARA(IBASE,2+LHASH+10*(IBASE(IPNODE)+MAXEXT),JPNODE)
         IBASE(IPLIST+INEXT)=JPNODE
         IBASE(JPNODE)=IBASE(IPNODE)+MAXEXT
         DO 15 I=2,1+LHASH+10*IBASE(IPNODE)
   15    IBASE(JPNODE+I)=IBASE(IPNODE+I)
         CALL RLSARA(IBASE(IPNODE))
         IPNODE=JPNODE
         IF(IBASE(IPLIST+IFATH).NE.-1) THEN
            JPNODE=IBASE(IPLIST+IFATH)
            JREF=IBASE(IPLIST+IDIR)
            IBASE(JPNODE+10*(JREF-1)+JDATA)=IPNODE
         ENDIF
      ENDIF
      IBASE(IPNODE+2+IPOS)=MAX(IREF,IBASE(IPNODE+2+IPOS))
      IBASE(IPNODE+1)=IREF
      DO 20 I=1,3
   20 IBASE(IPNODE+10*(IREF-1)+JCMT+I-1)=INAMT(I)
*
* STORE THE INFORMATION RELATIVE TO THE NEW INFORMATION ELEMENT.
   30 IBASE(IPNODE+10*(IREF-1)+JDATA)=IOFDUM
      IBASE(IPNODE+10*(IREF-1)+JJLON)=ILONG
      IBASE(IPNODE+10*(IREF-1)+JJTYP)=ITYPE
*
* STORE THE FIRST AND LAST ELEMENTS FOR VALIDATION PURPOSE.
      IF((ITYPE.EQ.1).OR.(ITYPE.EQ.3)) THEN
         IBASE(IPNODE+10*(IREF-1)+JIDAT)=IBASE(IOFDUM)
         IBASE(IPNODE+10*(IREF-1)+JIDAT+1)=IBASE(IOFDUM+ILONG-1)
      ELSE IF(ITYPE.EQ.2) THEN
         BASE(IPNODE+10*(IREF-1)+JIDAT)=BASE(IOFDUM)
         BASE(IPNODE+10*(IREF-1)+JIDAT+1)=BASE(IOFDUM+ILONG-1)
      ELSE IF((ITYPE.EQ.4).OR.(ITYPE.EQ.6)) THEN
         BASE(IPNODE+10*(IREF-1)+JIDAT)=BASE(IOFDUM)
         BASE(IPNODE+10*(IREF-1)+JIDAT+1)=BASE(IOFDUM+1)
         BASE(IPNODE+10*(IREF-1)+JIDAT+2)=BASE(IOFDUM+ILONG-2)
         BASE(IPNODE+10*(IREF-1)+JIDAT+3)=BASE(IOFDUM+ILONG-1)
      ELSE IF(ITYPE.EQ.5) THEN
         LBASE(IPNODE+10*(IREF-1)+JIDAT)=LBASE(IOFDUM)
         LBASE(IPNODE+10*(IREF-1)+JIDAT+1)=LBASE(IOFDUM+ILONG-1)
      ENDIF
      IOFDUM=0
      RETURN
      END
